pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT > Class Template Reference
Module keypoints

SUSANKeypoint implements a RGB-D extension of the SUSAN detector inluding normal directions variation in top of intensity variation. More...

`#include <pcl/keypoints/susan.h>`

Inheritance diagram for pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >:

## Public Types

typedef boost::shared_ptr< SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT > > | Ptr
typedef boost::shared_ptr< const SUSANKeypoint< PointInT, PointOutT, NormalT, Intensity > > | ConstPtr
typedef Keypoint< PointInT, PointOutT >::PointCloudIn | PointCloudIn
typedef Keypoint< PointInT, PointOutT >::PointCloudOut | PointCloudOut
typedef Keypoint< PointInT, PointOutT >::KdTree | KdTree
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
typedef pcl::PointCloud< NormalT > | PointCloudN
typedef PointCloudN::Ptr | PointCloudNPtr
typedef PointCloudN::ConstPtr | PointCloudNConstPtr
Public Types inherited from pcl::Keypoint< PointInT, PointOutT >
typedef boost::shared_ptr< Keypoint< PointInT, PointOutT > > | Ptr
typedef boost::shared_ptr< const Keypoint< PointInT, PointOutT > > | ConstPtr
typedef PCLBase< PointInT > | BaseClass
typedef pcl::search::Search< PointInT > | KdTree
typedef pcl::search::Search< PointInT >::Ptr | KdTreePtr
typedef pcl::PointCloud< PointInT > | PointCloudIn
typedef PointCloudIn::Ptr | PointCloudInPtr
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
typedef pcl::PointCloud< PointOutT > | PointCloudOut
typedef boost::function< int(int, double, std::vector< int > &, std::vector< float > &)> | SearchMethod
typedef boost::function< int(const PointCloudIn &cloud, int index, double, std::vector< int > &, std::vector< float > &)> | SearchMethodSurface
Public Types inherited from pcl::PCLBase< PointInT >
typedef pcl::PointCloud< PointInT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| SUSANKeypoint (float radius=0.01f, float distance_threshold=0.001f, float angular_threshold=0.0001f, float intensity_threshold=7.0f)
| Constructor. More...
virtual | ~SUSANKeypoint ()
| Empty destructor. More...
void | setRadius (float radius)
| set the radius for normal estimation and non maxima supression. More...
void | setDistanceThreshold (float distance_threshold)
void | setAngularThreshold (float angular_threshold)
| set the angular_threshold value for detecting corners. More...
void | setIntensityThreshold (float intensity_threshold)
| set the intensity_threshold value for detecting corners. More...
void | setNormals (const PointCloudNConstPtr &normals)
| set normals if precalculated normals are available. More...
virtual void | setSearchSurface (const PointCloudInConstPtr &cloud)
void | setNumberOfThreads (unsigned int nr_threads)
| Initialize the scheduler and set the number of threads to use. More...
void | setNonMaxSupression (bool nonmax)
| Apply non maxima suppression to the responses to keep strongest corners. More...
void | setGeometricValidation (bool validate)
| Filetr false positive using geometric criteria. More...
Public Member Functions inherited from pcl::Keypoint< PointInT, PointOutT >
| Keypoint ()
| Empty constructor. More...
virtual | ~Keypoint ()
| Empty destructor. More...
virtual void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to the input dataset that we need to estimate features at every point for. More...
PointCloudInConstPtr | getSearchSurface ()
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod ()
| Get a pointer to the search method used. More...
double | getSearchParameter ()
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch ()
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the key point detection. More...
double | getRadiusSearch ()
| Get the sphere radius used for determining the neighbors. More...
pcl::PointIndicesConstPtr | getKeypointsIndices ()
void | compute (PointCloudOut &output)
| Base method for key point detection for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
int | searchForNeighbors (int index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

bool | initCompute ()
void | detectKeypoints (PointCloudOut &output)
| Abstract key point detection method. More...
bool | isWithinNucleusCentroid (const Eigen::Vector3f &nucleus, const Eigen::Vector3f &centroid, const Eigen::Vector3f &nc, const PointInT &point) const
| return true if a point lies within the line between the nucleus and the centroid More...
Protected Member Functions inherited from pcl::Keypoint< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Additional Inherited Members

Protected Attributes inherited from pcl::Keypoint< PointInT, PointOutT >
std::string | name_
| The key point detection method's name. More...
SearchMethod | search_method_
| The search method template for indices. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (casted from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
pcl::PointIndicesPtr | keypoints_indices_
| Indices of the keypoints in the input cloud. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>
class pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >

SUSANKeypoint implements a RGB-D extension of the SUSAN detector inluding normal directions variation in top of intensity variation.

It is different from Harris in that it exploits normals directly so it is faster. Original paper "SUSAN — A New Approach to Low Level Image Processing", Smith, Stephen M. and Brady, J. Michael

Author
  Nizar Sallem

Definition at line 57 of file susan.h.

## Member Typedef Documentation

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

typedef boost::shared_ptr<const SUSANKeypoint<PointInT, PointOutT, NormalT, Intensity> > pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::ConstPtr

Definition at line 61 of file susan.h.

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

typedef Keypoint<PointInT, PointOutT>::KdTree pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::KdTree

Definition at line 65 of file susan.h.

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

typedef Keypoint<PointInT, PointOutT>::PointCloudIn pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::PointCloudIn

Definition at line 63 of file susan.h.

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

typedef PointCloudIn::ConstPtr pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::PointCloudInConstPtr

Definition at line 66 of file susan.h.

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

typedef pcl::PointCloud<NormalT> pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::PointCloudN

Definition at line 68 of file susan.h.

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

typedef PointCloudN::ConstPtr pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::PointCloudNConstPtr

Definition at line 70 of file susan.h.

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

typedef PointCloudN::Ptr pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::PointCloudNPtr

Definition at line 69 of file susan.h.

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

typedef Keypoint<PointInT, PointOutT>::PointCloudOut pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::PointCloudOut

Definition at line 64 of file susan.h.

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

typedef boost::shared_ptr<SUSANKeypoint<PointInT, PointOutT, NormalT, IntensityT> > pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::Ptr

Definition at line 60 of file susan.h.

## Constructor & Destructor Documentation

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::SUSANKeypoint | ( | float | radius = `0.01f`,
|  | float | distance_threshold = `0.001f`,
|  | float | angular_threshold = `0.0001f`,
|  | float | intensity_threshold = `7.0f`
| ) |  |

inline

Constructor.

Parameters

  [in] | radius | the radius for normal estimation as well as for non maxima suppression
  [in] | distance_threshold | to test if the nucleus is far enough from the centroid
  [in] | angular_threshold | to test if normals are parallel
  [in] | intensity_threshold | to test if points are of same color

Definition at line 89 of file susan.h.

References pcl::Keypoint< PointInT, PointOutT >::name_, and pcl::Keypoint< PointInT, PointOutT >::search_radius_.

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

virtual pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::~SUSANKeypoint | ( |  | ) |

inline virtual

Empty destructor.

Definition at line 108 of file susan.h.

References pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::detectKeypoints(), pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::initCompute(), pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::isWithinNucleusCentroid(), pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::setAngularThreshold(), pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::setDistanceThreshold(), pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::setGeometricValidation(), pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::setIntensityThreshold(), pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::setNonMaxSupression(), pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::setNormals(), pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::setNumberOfThreads(), pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::setRadius(), and pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::setSearchSurface().

## Member Function Documentation

template<typename PointInT , typename PointOutT , typename NormalT , typename IntensityT >

void pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::detectKeypoints | ( | PointCloudOut & | output | ) |

protected virtual

Abstract key point detection method.

Implements pcl::Keypoint< PointInT, PointOutT >.

Definition at line 303 of file susan.hpp.

References pcl::isFinite().

Referenced by pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::~SUSANKeypoint().

template<typename PointInT , typename PointOutT , typename NormalT , typename IntensityT >

bool pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::initCompute | ( |  | ) |

protected virtual

Reimplemented from pcl::Keypoint< PointInT, PointOutT >.

Definition at line 215 of file susan.hpp.

References pcl::Feature< PointInT, PointOutT >::compute(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::setInputCloud(), pcl::NormalEstimation< PointInT, PointOutT >::setInputCloud(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::setNormalEstimationMethod(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::setNormalSmoothingSize(), and pcl::Feature< PointInT, PointOutT >::setRadiusSearch().

Referenced by pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::~SUSANKeypoint().

template<typename PointInT , typename PointOutT , typename NormalT , typename IntensityT >

bool pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::isWithinNucleusCentroid | ( | const Eigen::Vector3f & | nucleus,
|  | const Eigen::Vector3f & | centroid,
|  | const Eigen::Vector3f & | nc,
|  | const PointInT & | point
| ) |  | const

protected

return true if a point lies within the line between the nucleus and the centroid

Parameters

  [in] | nucleus | coordinate of the nucleus
  [in] | centroid | of the SUSAN
  [in] | nc | to centroid vector (used to speed up since it is constant for a given neighborhood)
  [in] | point | the query point to test against

Returns
  true if the point lies within [nucleus centroid]

Definition at line 255 of file susan.hpp.

Referenced by pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::~SUSANKeypoint().

template<typename PointInT , typename PointOutT , typename NormalT , typename IntensityT >

void pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::setAngularThreshold | ( | float | angular_threshold | ) |

set the angular_threshold value for detecting corners.

Normals are considered as parallel if 1 - angular_threshold <= (Ni.Nj) <= 1

Parameters

  [in] | angular_threshold |

Definition at line 75 of file susan.hpp.

Referenced by pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::~SUSANKeypoint().

template<typename PointInT , typename PointOutT , typename NormalT , typename IntensityT >

void pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::setDistanceThreshold | ( | float | distance_threshold | ) |

Definition at line 68 of file susan.hpp.

Referenced by pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::~SUSANKeypoint().

template<typename PointInT , typename PointOutT , typename NormalT , typename IntensityT >

void pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::setGeometricValidation | ( | bool | validate | ) |

Filetr false positive using geometric criteria.

The nucleus and the centroid should at least distance_threshold_ from each other AND all the points belonging to the USAN must be within the segment [nucleus centroid].

Parameters

  [in] | validate |

Definition at line 54 of file susan.hpp.

Referenced by pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::~SUSANKeypoint().

template<typename PointInT , typename PointOutT , typename NormalT , typename IntensityT >

void pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::setIntensityThreshold | ( | float | intensity_threshold | ) |

set the intensity_threshold value for detecting corners.

Parameters

  [in] | intensity_threshold |

Definition at line 82 of file susan.hpp.

Referenced by pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::~SUSANKeypoint().

template<typename PointInT , typename PointOutT , typename NormalT , typename IntensityT >

void pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::setNonMaxSupression | ( | bool | nonmax | ) |

Apply non maxima suppression to the responses to keep strongest corners.

Note
  in SUSAN points with less response or stronger corners

Definition at line 47 of file susan.hpp.

Referenced by pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::~SUSANKeypoint().

template<typename PointInT , typename PointOutT , typename NormalT , typename IntensityT >

void pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::setNormals | ( | const PointCloudNConstPtr & | normals | ) |

set normals if precalculated normals are available.

Parameters

  normals |

Definition at line 89 of file susan.hpp.

Referenced by pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::~SUSANKeypoint().

template<typename PointInT , typename PointOutT , typename NormalT , typename IntensityT >

void pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::setNumberOfThreads | ( | unsigned int | nr_threads | ) |

Initialize the scheduler and set the number of threads to use.

Parameters

  nr_threads | the number of hardware threads to use (0 sets the value back to automatic)

Definition at line 104 of file susan.hpp.

Referenced by pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::~SUSANKeypoint().

template<typename PointInT , typename PointOutT , typename NormalT , typename IntensityT >

void pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::setRadius | ( | float | radius | ) |

set the radius for normal estimation and non maxima supression.

Parameters

  [in] | radius |

Definition at line 61 of file susan.hpp.

Referenced by pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::~SUSANKeypoint().

template<typename PointInT , typename PointOutT , typename NormalT , typename IntensityT >

void pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::setSearchSurface | ( | const PointCloudInConstPtr & | cloud | ) |

virtual

Definition at line 96 of file susan.hpp.

Referenced by pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::~SUSANKeypoint().

The documentation for this class was generated from the following files:

- /build/pcl-6_P28C/pcl-1.7.2/keypoints/include/pcl/keypoints/susan.h
- /build/pcl-6_P28C/pcl-1.7.2/keypoints/include/pcl/keypoints/impl/susan.hpp